diff --git a/src/main/java/net/minecraft/server/world/ConvertProgressUpdater.java b/src/main/java/net/minecraft/server/world/ConvertProgressUpdater.java
index 7ccbf75d3..3ef1589bf 100644
--- a/src/main/java/net/minecraft/server/world/ConvertProgressUpdater.java
+++ b/src/main/java/net/minecraft/server/world/ConvertProgressUpdater.java
@@ -26,7 +26,7 @@ public class ConvertProgressUpdater
         if(System.currentTimeMillis() - lastTimeMillis >= 1000L)
         {
             lastTimeMillis = System.currentTimeMillis();
-            MinecraftServer.logger.info("Converting... " + i + "%");
+            MinecraftServer.LOGGER.info("Converting... " + i + "%");
         }
     }
 
diff --git a/src/main/java/net/minecraft/server/world/WorldManager.java b/src/main/java/net/minecraft/server/world/WorldManager.java
index 62e3d8f79..cb300ce19 100644
--- a/src/main/java/net/minecraft/server/world/WorldManager.java
+++ b/src/main/java/net/minecraft/server/world/WorldManager.java
@@ -3,6 +3,7 @@ package net.minecraft.server.world;
 import java.util.HashSet;
 import java.util.Set;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.ItemEntity;
@@ -13,20 +14,16 @@ import net.minecraft.core.sound.SoundTypes;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.server.MinecraftServer;
-
-// Referenced classes of package net.minecraft.src:
-//            IWorldAccess, WorldServer, WorldProvider, EntityTracker, 
-//            ServerConfigurationManager, Packet61DoorChange, Entity, BlockEntity,
-//            Player
+import org.slf4j.Logger;
 
 public class WorldManager
     implements LevelListener
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
+	private static final Set<String> unknownSoundTypes = new HashSet<>();
 
-	private static Set<String> unknownSoundTypes = new HashSet<>();
-
-    private MinecraftServer mcServer;
-    private WorldServer worldServer;
+    private final MinecraftServer mcServer;
+    private final WorldServer worldServer;
 
     public WorldManager(MinecraftServer minecraftserver, WorldServer worldserver)
     {
@@ -75,7 +72,7 @@ public class WorldManager
 		int soundId = SoundTypes.getSoundId(soundPath);
 		if(soundId == -1) {
 			if(!unknownSoundTypes.contains(soundPath)) {
-				System.out.println("Unable to play unknown sound '" + soundPath + "'!");
+                LOGGER.warn("Unable to play unknown sound '{}'!", soundPath);
 				unknownSoundTypes.add(soundPath);
 			}
 			return;
diff --git a/src/main/java/net/minecraft/server/world/WorldServer.java b/src/main/java/net/minecraft/server/world/WorldServer.java
index 29cc2d08a..4291a924d 100644
--- a/src/main/java/net/minecraft/server/world/WorldServer.java
+++ b/src/main/java/net/minecraft/server/world/WorldServer.java
@@ -86,7 +86,7 @@ public class WorldServer extends World
         {
             i1 = l;
         }
-        return i1 > 16 || mcServer.playerList.isOp(entityplayer.username);
+        return i1 > 16 || mcServer.playerList.isOp(entityplayer.uuid);
     }
 
     @Override
@@ -252,6 +252,17 @@ public class WorldServer extends World
         mcServer.playerList.sendPacketToAllPlayers(new ChatPacket(message));
     }
 
+    @Override
+    public void addRainbow(int rainbowTicks){
+        byte b0 = (byte) ((rainbowTicks >> 24) & 0xFF);
+        byte b1 = (byte) ((rainbowTicks >> 16) & 0xFF);
+        byte b2 = (byte) ((rainbowTicks >>  8) & 0xFF);
+        byte b3 = (byte) ((rainbowTicks >>  0) & 0xFF);
+//        System.out.printf("b0:%s b1:%s b2:%s b3:%s\n", b0, b1, b2, b3);
+//        System.out.println("Sent rainbow with " + rainbowTicks + " ticks!");
+        mcServer.playerList.sendPacketToAllPlayersInDimension(new CustomPayloadPacket("BTA|RainbowStart", new byte[]{b0, b1, b2, b3}), dimension.id);
+        super.addRainbow(rainbowTicks);
+    }
     public ChunkProviderServer chunkProviderServer;
     public boolean field_819_z;
     public boolean levelSaving;
diff --git a/src/main/java/net/minecraft/server/world/chunk/provider/ChunkProviderServer.java b/src/main/java/net/minecraft/server/world/chunk/provider/ChunkProviderServer.java
index ef9680909..831209fee 100644
--- a/src/main/java/net/minecraft/server/world/chunk/provider/ChunkProviderServer.java
+++ b/src/main/java/net/minecraft/server/world/chunk/provider/ChunkProviderServer.java
@@ -1,10 +1,12 @@
 package net.minecraft.server.world.chunk.provider;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.world.ProgressListener;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
 import net.minecraft.server.world.WorldServer;
 import net.minecraft.core.world.chunk.*;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
+import org.slf4j.Logger;
 
 import java.io.IOException;
 import java.util.*;
@@ -12,6 +14,15 @@ import java.util.*;
 public class ChunkProviderServer
     implements IChunkProvider
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
+    private final Set<Integer> droppedChunksSet;
+    private final Chunk emptyChunk;
+    public ChunkGenerator chunkGenerator;
+    private final IChunkLoader chunkLoader;
+    public boolean chunkLoadOverride;
+    private final Map<Integer, Chunk> chunkMap;
+    private final List<Chunk> chunkList;
+    private final WorldServer world;
 
     public ChunkProviderServer(WorldServer world, IChunkLoader chunkLoader, ChunkGenerator chunkGenerator)
     {
@@ -168,7 +179,7 @@ public class ChunkProviderServer
         }
         catch (Exception exception)
         {
-            exception.printStackTrace();
+            LOGGER.error("Failed to load chunk at X:{}, Z:{} to disk!", chunkX, chunkZ, exception);
         }
         return null;
     }
@@ -186,7 +197,7 @@ public class ChunkProviderServer
         }
         catch (IOException ioexception)
         {
-            ioexception.printStackTrace();
+            LOGGER.error("Failed to save chunk at X:{}, Z:{} to disk!", chunk.xPosition, chunk.zPosition, ioexception);
         }
     }
 
@@ -275,13 +286,4 @@ public class ChunkProviderServer
     public void setCurrentChunkOver(int chunkX, int chunkZ) {
         // Do nothing
     }
-
-    private final Set<Integer> droppedChunksSet;
-    private final Chunk emptyChunk;
-    public ChunkGenerator chunkGenerator;
-    private final IChunkLoader chunkLoader;
-    public boolean chunkLoadOverride;
-    private final Map<Integer, Chunk> chunkMap;
-    private final List<Chunk> chunkList;
-    private final WorldServer world;
 }
diff --git a/src/main/java/org/useless/seedviewer/SeedViewerMain.java b/src/main/java/org/useless/seedviewer/SeedViewerMain.java
new file mode 100644
index 000000000..a88e811f8
--- /dev/null
+++ b/src/main/java/org/useless/seedviewer/SeedViewerMain.java
@@ -0,0 +1,54 @@
+package org.useless.seedviewer;
+
+import com.formdev.flatlaf.FlatDarculaLaf;
+import com.mojang.logging.LogUtils;
+import org.jetbrains.annotations.NotNull;
+import org.slf4j.Logger;
+import org.useless.seedviewer.gui.SeedViewer;
+
+import javax.swing.*;
+import java.util.Properties;
+
+public class SeedViewerMain {
+    public static final String VERSION = "1.1.1";
+    public static final Logger LOGGER = LogUtils.getLogger();
+
+    public static void main(String[] args) {
+        try { // Validate BTA jar is present
+            Class.forName("net.minecraft.core.world.biome.provider.BiomeProviderOverworld");
+        } catch (ClassNotFoundException e) {
+            LOGGER.error("Could not locate BTA jar! Canceling Startup!", e);
+            return;
+        }
+        try {
+            UIManager.setLookAndFeel( new FlatDarculaLaf() );
+        } catch( Exception ex ) {
+            LOGGER.error("Failed to initialize LaF theme!", ex);
+        }
+        new SeedViewer(argsToProperties(args));
+    }
+
+    /**
+     * Reads all provided strings for key value pairs, for strings which fail to follow the
+     * key value format will be ignored
+     * @param args Array of strings formated like { -key1, value1, -key2, value2}
+     * @return Properties map representation of provided key value pairs
+     */
+    public static @NotNull Properties argsToProperties(String[] args) {
+        Properties properties = new Properties();
+        for (int i = 0; i < args.length; i++) {
+            String arg = args[i];
+            if (arg.startsWith("-")) {
+                String key = arg.substring(1);
+                if (key.isEmpty()) continue;
+                if (i >= args.length - 1) continue; // Ensure that can't index out of bound
+                String value = args[++i]; // Get next argument and shift pointer
+                properties.setProperty(key, value);
+            } else {
+                LOGGER.error("Unrecognized argument '{}'!", arg);
+            }
+
+        }
+        return properties;
+    }
+}
\ No newline at end of file
diff --git a/src/main/java/org/useless/seedviewer/TestChunkProvider.java b/src/main/java/org/useless/seedviewer/TestChunkProvider.java
new file mode 100644
index 000000000..965e87d40
--- /dev/null
+++ b/src/main/java/org/useless/seedviewer/TestChunkProvider.java
@@ -0,0 +1,56 @@
+package org.useless.seedviewer;
+
+import org.useless.seedviewer.collections.ChunkLocation;
+import org.useless.seedviewer.collections.ChunkPos2D;
+import org.useless.seedviewer.collections.ChunkPos3D;
+import org.useless.seedviewer.collections.NamespaceID;
+import org.useless.seedviewer.data.Biome;
+import org.useless.seedviewer.data.Chunk;
+import org.useless.seedviewer.gui.ChunkProvider;
+
+import java.awt.*;
+
+public class TestChunkProvider implements ChunkProvider {
+    @Override
+    public Chunk getChunk(ChunkLocation location) {
+        return new Chunk() {
+            @Override
+            public Biome getBiome(ChunkPos3D pos) {
+                return new Biome() {
+                    @Override
+                    public String getName() {
+                        return "Test Biome";
+                    }
+
+                    @Override
+                    public NamespaceID getID() {
+                        return new NamespaceID("viewer:test");
+                    }
+
+                    @Override
+                    public int getColor() {
+                        int r = (pos.x << 3) & 0xFF;
+                        int g = (pos.y) & 0xFF;
+                        int b = (pos.z << 3) & 0xFF;
+                        return r << 16 | g << 8 | b;
+                    }
+                };
+            }
+
+            @Override
+            public int getBlockColor(ChunkPos3D pos) {
+                return 0;
+            }
+
+            @Override
+            public int getHeight(ChunkPos2D pos) {
+                return 128;
+            }
+
+            @Override
+            public int getWaterDepth(ChunkPos2D pos) {
+                return 0;
+            }
+        };
+    }
+}
diff --git a/src/main/java/org/useless/seedviewer/bta/BTABiome.java b/src/main/java/org/useless/seedviewer/bta/BTABiome.java
new file mode 100644
index 000000000..0088af62d
--- /dev/null
+++ b/src/main/java/org/useless/seedviewer/bta/BTABiome.java
@@ -0,0 +1,29 @@
+package org.useless.seedviewer.bta;
+
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.lang.I18n;
+import org.useless.seedviewer.collections.NamespaceID;
+import org.useless.seedviewer.data.Biome;
+
+public class BTABiome implements Biome {
+    private final net.minecraft.core.world.biome.Biome biome;
+    public BTABiome(net.minecraft.core.world.biome.Biome biome) {
+        this.biome = biome;
+    }
+    @Override
+    public String getName() {
+        if (biome == null) return "Unknown";
+        return I18n.getInstance().translateKey(biome.translationKey);
+    }
+
+    @Override
+    public NamespaceID getID() {
+        return new NamespaceID(Registries.BIOMES.getKey(biome));
+    }
+
+    @Override
+    public int getColor() {
+        if (biome == null) return 0x00000000;
+        return biome.color;
+    }
+}
diff --git a/src/main/java/org/useless/seedviewer/bta/BTAChunkProvider.java b/src/main/java/org/useless/seedviewer/bta/BTAChunkProvider.java
new file mode 100644
index 000000000..eddf95ff2
--- /dev/null
+++ b/src/main/java/org/useless/seedviewer/bta/BTAChunkProvider.java
@@ -0,0 +1,65 @@
+package org.useless.seedviewer.bta;
+
+import com.mojang.logging.LogUtils;
+import net.minecraft.core.Global;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.world.biome.Biomes;
+import net.minecraft.core.world.biome.provider.BiomeProvider;
+import net.minecraft.core.world.biome.provider.BiomeProviderOverworld;
+import net.minecraft.core.world.save.LevelData;
+import net.minecraft.core.world.type.WorldTypes;
+import org.slf4j.Logger;
+import org.useless.seedviewer.bta.worldloader.ChunkLoader;
+import org.useless.seedviewer.collections.ChunkLocation;
+import org.useless.seedviewer.data.Chunk;
+import org.useless.seedviewer.gui.ChunkProvider;
+
+import java.io.File;
+import java.io.IOException;
+
+public class BTAChunkProvider implements ChunkProvider {
+    private static final Logger LOGGER = LogUtils.getLogger();
+    static {
+        if (Global.accessor == null) {
+            Global.accessor = new DummyMinecraft();
+            Blocks.init();
+            Items.init();
+            new Registries();
+            Biomes.init();
+            WorldTypes.init();
+            BiomeProviderOverworld.init();
+            I18n.initialize("en_US");
+        }
+    }
+
+    ChunkLoader chunkLoader = null;
+    private final BiomeProvider biomeProvider;
+
+
+    public BTAChunkProvider(long seed) {
+        biomeProvider = new BiomeProviderOverworld(seed, WorldTypes.OVERWORLD_EXTENDED);
+    }
+
+    public BTAChunkProvider(File worldFolder, LevelData data) {
+        biomeProvider = new BiomeProviderOverworld(data.getRandomSeed(), WorldTypes.OVERWORLD_EXTENDED);
+        chunkLoader = new ChunkLoader(worldFolder, 0);
+    }
+    @Override
+    public Chunk getChunk(ChunkLocation location) {
+        if (chunkLoader != null) {
+            try {
+                net.minecraft.core.world.chunk.Chunk c = chunkLoader.loadChunk(location);
+                if (c != null) {
+                    return new BTAComplexChunk(c);
+                }
+            } catch (IOException e) {
+                LOGGER.error("Failed to load chunk data for chunk {}, {}", location.x, location.z, e);
+            }
+        }
+        return new BTASimpleChunk(location, biomeProvider);
+    }
+
+}
diff --git a/src/main/java/org/useless/seedviewer/bta/BTAComplexChunk.java b/src/main/java/org/useless/seedviewer/bta/BTAComplexChunk.java
new file mode 100644
index 000000000..ee8677775
--- /dev/null
+++ b/src/main/java/org/useless/seedviewer/bta/BTAComplexChunk.java
@@ -0,0 +1,51 @@
+package org.useless.seedviewer.bta;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.MaterialColor;
+import org.jetbrains.annotations.NotNull;
+import org.useless.seedviewer.collections.ChunkPos2D;
+import org.useless.seedviewer.collections.ChunkPos3D;
+import org.useless.seedviewer.data.Biome;
+import org.useless.seedviewer.data.Chunk;
+
+import java.awt.*;
+
+public class BTAComplexChunk implements Chunk {
+    private final net.minecraft.core.world.chunk.Chunk chunk;
+    public BTAComplexChunk(@NotNull net.minecraft.core.world.chunk.Chunk chunk) {
+        this.chunk = chunk;
+    }
+    @Override
+    public Biome getBiome(ChunkPos3D pos) {
+        return new BTABiome(chunk.getBlockBiome(pos.x, pos.y, pos.z));
+    }
+
+    @Override
+    public int getBlockColor(ChunkPos3D pos) {
+        Block b = Block.getBlock(chunk.getBlockID(pos.x, pos.y, pos.z));
+        if (b == null) return 0;
+        int meta = chunk.getBlockMetadata(pos.x, pos.y, pos.z);
+        return MaterialColor.getColorFromIndex(MaterialColor.getColorIndexFromBlock(b, meta)) | 0xFF_00_00_00;
+    }
+
+    @Override
+    public int getHeight(ChunkPos2D pos) {
+        return chunk.getHeightValue(pos.x, pos.z);
+    }
+
+    @Override
+    public int getWaterDepth(ChunkPos2D pos) {
+        int start = getHeight(pos) - 1;
+        int depth = 0;
+        while (true) {
+            int y = start - depth;
+            if (y < 0) break;
+            Block b = Block.getBlock(chunk.getBlockID(pos.x, y, pos.z));
+            if (b == null) break;
+            if (b.blockMaterial != Material.water) break;
+            depth++;
+        }
+        return depth;
+    }
+}
diff --git a/src/main/java/org/useless/seedviewer/bta/BTASimpleChunk.java b/src/main/java/org/useless/seedviewer/bta/BTASimpleChunk.java
new file mode 100644
index 000000000..657415819
--- /dev/null
+++ b/src/main/java/org/useless/seedviewer/bta/BTASimpleChunk.java
@@ -0,0 +1,38 @@
+package org.useless.seedviewer.bta;
+
+import net.minecraft.core.world.biome.provider.BiomeProvider;
+import org.useless.seedviewer.collections.ChunkLocation;
+import org.useless.seedviewer.collections.ChunkPos2D;
+import org.useless.seedviewer.collections.ChunkPos3D;
+import org.useless.seedviewer.data.Biome;
+import org.useless.seedviewer.data.Chunk;
+
+import java.awt.*;
+
+public class BTASimpleChunk implements Chunk {
+    private final ChunkLocation location;
+    private final BiomeProvider provider;
+    public BTASimpleChunk(ChunkLocation location, BiomeProvider biomeProvider) {
+        this.location = location;
+        provider = biomeProvider;
+    }
+    @Override
+    public Biome getBiome(ChunkPos3D pos) {
+        return new BTABiome(provider.getBiome(location.x * Chunk.CHUNK_SIZE_X + pos.x, pos.y, location.z * Chunk.CHUNK_SIZE_Z + pos.z));
+    }
+
+    @Override
+    public int getBlockColor(ChunkPos3D pos) {
+        return 0;
+    }
+
+    @Override
+    public int getHeight(ChunkPos2D pos) {
+        return 128;
+    }
+
+    @Override
+    public int getWaterDepth(ChunkPos2D pos) {
+        return 0;
+    }
+}
diff --git a/src/main/java/org/useless/seedviewer/bta/BTAWorld.java b/src/main/java/org/useless/seedviewer/bta/BTAWorld.java
new file mode 100644
index 000000000..34329fad4
--- /dev/null
+++ b/src/main/java/org/useless/seedviewer/bta/BTAWorld.java
@@ -0,0 +1,43 @@
+package org.useless.seedviewer.bta;
+
+import net.minecraft.core.world.save.LevelData;
+import org.jetbrains.annotations.NotNull;
+import org.useless.seedviewer.bta.worldloader.LevelDataLoader;
+import org.useless.seedviewer.data.World;
+import org.useless.seedviewer.gui.ChunkProvider;
+
+import java.io.File;
+import java.util.Objects;
+
+public class BTAWorld implements World {
+    private final @NotNull File worldFolder;
+    private final LevelData data;
+    public BTAWorld(@NotNull File worldFolder) {
+        this.worldFolder = worldFolder;
+        this.data = Objects.requireNonNull(LevelDataLoader.getLevelData(worldFolder), "Failed to get level data from world '" + worldFolder + "'");
+    }
+    @Override
+    public File getFolder() {
+        return worldFolder;
+    }
+
+    @Override
+    public long getSeed() {
+        return data.getRandomSeed();
+    }
+
+    @Override
+    public String getName() {
+        return data.getWorldName();
+    }
+
+    @Override
+    public long getLastPlayed() {
+        return data.getLastTimePlayed();
+    }
+
+    @Override
+    public ChunkProvider getChunkProvider() {
+        return new BTAChunkProvider(worldFolder, data);
+    }
+}
diff --git a/src/main/java/org/useless/seedviewer/bta/DummyMinecraft.java b/src/main/java/org/useless/seedviewer/bta/DummyMinecraft.java
new file mode 100644
index 000000000..20be08c87
--- /dev/null
+++ b/src/main/java/org/useless/seedviewer/bta/DummyMinecraft.java
@@ -0,0 +1,33 @@
+package org.useless.seedviewer.bta;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.world.chunk.provider.ChunkProviderStatic;
+import net.minecraft.core.MinecraftAccessor;
+import net.minecraft.core.entity.SkinVariantList;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.chunk.IChunkLoader;
+import net.minecraft.core.world.chunk.provider.IChunkProvider;
+
+import java.io.File;
+
+public class DummyMinecraft implements MinecraftAccessor {
+    public File getMinecraftDir() {
+        return Minecraft.getAppDir("minecraft-bta");
+    }
+
+    public IChunkProvider createChunkProvider(World world, IChunkLoader chunkLoader) {
+        return new ChunkProviderStatic(world, chunkLoader, world.getWorldType().createChunkGenerator(world));
+    }
+
+    public int getAutosaveTimer() {
+        return 0;
+    }
+
+    public SkinVariantList getSkinVariantList() {
+        return null;
+    }
+
+    public String getMinecraftVersion() {
+        return null;
+    }
+}
diff --git a/src/main/java/org/useless/seedviewer/bta/worldloader/ChunkLoader.java b/src/main/java/org/useless/seedviewer/bta/worldloader/ChunkLoader.java
new file mode 100644
index 000000000..1060f5454
--- /dev/null
+++ b/src/main/java/org/useless/seedviewer/bta/worldloader/ChunkLoader.java
@@ -0,0 +1,114 @@
+package org.useless.seedviewer.bta.worldloader;
+
+import com.mojang.logging.LogUtils;
+import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.NbtIo;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.chunk.Chunk;
+import net.minecraft.core.world.chunk.ChunkLoaderLegacy;
+import net.minecraft.core.world.chunk.reader.ChunkReader;
+import net.minecraft.core.world.chunk.reader.ChunkReaderLegacy;
+import net.minecraft.core.world.chunk.reader.ChunkReaderVersion1;
+import net.minecraft.core.world.chunk.reader.ChunkReaderVersion2;
+import net.minecraft.core.world.save.mcregion.RegionFileCache;
+import org.slf4j.Logger;
+import org.useless.seedviewer.collections.ChunkLocation;
+
+import java.io.DataInputStream;
+import java.io.File;
+import java.io.IOException;
+import java.util.Arrays;
+import java.util.Map;
+
+public class ChunkLoader {
+    private static final Logger LOGGER = LogUtils.getLogger();
+    private static final World dummyWorld = new World();
+    private final File dimensionDir;
+    public ChunkLoader(File worldFolder, int dimension) {
+        this.dimensionDir = new File(worldFolder, "dimensions/" + dimension);
+    }
+
+    public boolean chunkExists(ChunkLocation location) {
+        DataInputStream regionStream = RegionFileCache.getChunkInputStream(dimensionDir, location.x, location.z);
+        CompoundTag tag;
+        if(regionStream != null)
+        {
+            try {
+                tag = NbtIo.read(regionStream);
+            } catch (IOException e) {
+                LOGGER.error("Failed to read tag for location {}, {}", location.x, location.z, e);
+                return false;
+            }
+        }
+        else
+        {
+            return false;
+        }
+        return tag.containsKey("Level");
+    }
+
+    public Chunk loadChunk(ChunkLocation location) throws IOException {
+        DataInputStream regionStream = RegionFileCache.getChunkInputStream(dimensionDir, location.x, location.z);
+        CompoundTag tag;
+        if(regionStream != null)
+        {
+            tag = NbtIo.read(regionStream);
+        }
+        else
+        {
+            return null;
+        }
+        if(!tag.containsKey("Level"))
+        {
+            LOGGER.error("Chunk file at {},{} is missing level data, skipping", location.x, location.z);
+            return null;
+        }
+        return loadChunkFromCompound(tag.getCompound("Level"));
+    }
+
+    public static Chunk loadChunkFromCompound(CompoundTag tag) {
+        int version = tag.getIntegerOrDefault("Version", -1);
+        ChunkReader reader = getChunkReaderByVersion(tag, version);
+        int x = reader.getX();
+        int z = reader.getZ();
+        Chunk chunk = new Chunk(dummyWorld, x, z);
+        chunk.heightMap = reader.getHeightMap();
+        chunk.averageBlockHeight = reader.getAverageBlockHeight();
+        chunk.isTerrainPopulated = reader.getIsTerrainPopulated();
+        chunk.temperature = reader.getTemperatureMap();
+        chunk.humidity = reader.getHumidityMap();
+        Map<Integer, String> biomeRegistry = reader.getBiomeRegistry();
+
+        for(int i = 0; i < Chunk.CHUNK_SECTIONS; ++i) {
+            ChunkLoaderLegacy.loadChunkSectionFromCompound(chunk.getSection(i), reader, biomeRegistry);
+        }
+
+        if (chunk.heightMap == null) {
+            chunk.heightMap = new short[256];
+            chunk.recalcHeightmap();
+        }
+
+        if (chunk.temperature == null || chunk.temperature.length == 0) {
+            chunk.temperature = new double[256];
+            Arrays.fill(chunk.temperature, Double.NEGATIVE_INFINITY);
+        }
+
+        if (chunk.humidity == null || chunk.humidity.length == 0) {
+            chunk.humidity = new double[256];
+            Arrays.fill(chunk.humidity, Double.NEGATIVE_INFINITY);
+        }
+
+        return chunk;
+    }
+    private static ChunkReader getChunkReaderByVersion(CompoundTag tag, int version) {
+        switch (version) {
+            case 1:
+                return new ChunkReaderVersion1(null, tag);
+            case 2:
+                return new ChunkReaderVersion2(null, tag);
+            default:
+                return new ChunkReaderLegacy(null, tag);
+        }
+    }
+
+}
diff --git a/src/main/java/org/useless/seedviewer/bta/worldloader/DimensionDataLoader.java b/src/main/java/org/useless/seedviewer/bta/worldloader/DimensionDataLoader.java
new file mode 100644
index 000000000..cb7a5026c
--- /dev/null
+++ b/src/main/java/org/useless/seedviewer/bta/worldloader/DimensionDataLoader.java
@@ -0,0 +1,63 @@
+package org.useless.seedviewer.bta.worldloader;
+
+import com.mojang.logging.LogUtils;
+import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.NbtIo;
+import net.minecraft.core.world.save.DimensionData;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.slf4j.Logger;
+
+import java.io.File;
+import java.nio.file.Files;
+import java.util.Objects;
+
+public class DimensionDataLoader {
+    private static final Logger LOGGER = LogUtils.getLogger();
+    @Nullable
+    public static DimensionData getDimensionData(@NotNull File worldDir, int dimensionId) {
+        Objects.requireNonNull(worldDir, "WorldDir must not be null!");
+        CompoundTag tag = getDimensionDataRaw(worldDir, dimensionId);
+        if (tag == null) return null;
+        return new DimensionData(tag);
+    }
+
+    @Nullable
+    public static CompoundTag getDimensionDataRaw(@NotNull File worldDir, int dimensionId)
+    {
+        if(!worldDir.exists())
+        {
+            return null;
+        }
+        File dimensionsDir = new File(worldDir, "dimensions");
+        File dimensionDir = new File(dimensionsDir, "" + dimensionId);
+        File dimensionDat = new File(dimensionDir, "dimension.dat");
+        if (dimensionDat.exists())
+        {
+            try
+            {
+                CompoundTag nbtRoot = NbtIo.readCompressed(Files.newInputStream(dimensionDat.toPath()));
+                return nbtRoot.getCompound("Data");
+            }
+            catch (Exception ex)
+            {
+                LOGGER.error("Error parsing 'dimension.dat' in '{}' dimension {}", worldDir, dimensionId, ex);
+            }
+        }
+        dimensionDat = new File(dimensionDir, "dimension.dat_old");
+        if (dimensionDat.exists())
+        {
+            try
+            {
+                CompoundTag oldNbtRoot = NbtIo.readCompressed(Files.newInputStream(dimensionDat.toPath()));
+                return oldNbtRoot.getCompound("Data");
+            }
+            catch (Exception ex)
+            {
+                LOGGER.error("Error parsing 'dimension.dat_old' in '{}' dimension {}", worldDir, dimensionId, ex);
+            }
+        }
+
+        return null;
+    }
+}
diff --git a/src/main/java/org/useless/seedviewer/bta/worldloader/LevelDataLoader.java b/src/main/java/org/useless/seedviewer/bta/worldloader/LevelDataLoader.java
new file mode 100644
index 000000000..991d09397
--- /dev/null
+++ b/src/main/java/org/useless/seedviewer/bta/worldloader/LevelDataLoader.java
@@ -0,0 +1,63 @@
+package org.useless.seedviewer.bta.worldloader;
+
+import com.mojang.logging.LogUtils;
+import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.NbtIo;
+import net.minecraft.core.world.save.LevelData;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.slf4j.Logger;
+
+import java.io.File;
+import java.nio.file.Files;
+import java.util.Objects;
+
+public class LevelDataLoader {
+    private static final Logger LOGGER = LogUtils.getLogger();
+
+    @Nullable
+    public static LevelData getLevelData(@NotNull File worldDir)
+    {
+        Objects.requireNonNull(worldDir, "WorldDir must not be null!");
+        CompoundTag tag = getLevelDataRaw(worldDir);
+        if (tag == null) return null;
+        return new LevelData(tag);
+    }
+
+    @Nullable
+    public static CompoundTag getLevelDataRaw(@NotNull File worldDir)
+    {
+        Objects.requireNonNull(worldDir, "WorldDir must not be null!");
+        if(!worldDir.exists())
+        {
+            return null;
+        }
+        File worldLevelDat = new File(worldDir, "level.dat");
+        if(worldLevelDat.exists())
+        {
+            try
+            {
+                CompoundTag nbtRoot = NbtIo.readCompressed(Files.newInputStream(worldLevelDat.toPath()));
+                return nbtRoot.getCompound("Data");
+            }
+            catch(Exception ex)
+            {
+                LOGGER.error("Error parsing 'level.dat' in '{}'", worldDir, ex);
+            }
+        }
+        worldLevelDat = new File(worldDir, "level.dat_old");
+        if(worldLevelDat.exists())
+        {
+            try
+            {
+                CompoundTag oldNbtRoot = NbtIo.readCompressed(Files.newInputStream(worldLevelDat.toPath()));
+                return oldNbtRoot.getCompound("Data");
+            }
+            catch(Exception ex)
+            {
+                LOGGER.error("Error parsing 'level.dat_old' in '{}'", worldDir, ex);
+            }
+        }
+        return null;
+    }
+}
diff --git a/src/main/java/org/useless/seedviewer/collections/BlockPos2D.java b/src/main/java/org/useless/seedviewer/collections/BlockPos2D.java
new file mode 100644
index 000000000..20a2bba7b
--- /dev/null
+++ b/src/main/java/org/useless/seedviewer/collections/BlockPos2D.java
@@ -0,0 +1,34 @@
+package org.useless.seedviewer.collections;
+
+import java.util.Objects;
+
+public class BlockPos2D {
+    public final int x;
+    public final int z;
+
+    public BlockPos2D(int x, int z) {
+        this.x = x;
+        this.z = z;
+    }
+
+    @Override
+    public boolean equals(Object o) {
+        if (this == o) return true;
+        if (o == null || getClass() != o.getClass()) return false;
+        BlockPos2D blockPos2D = (BlockPos2D) o;
+        return x == blockPos2D.x && z == blockPos2D.z;
+    }
+
+    @Override
+    public int hashCode() {
+        return Objects.hash(x, z);
+    }
+
+    @Override
+    public String toString() {
+        return "BlockPos3D{" +
+            "x=" + x +
+            ", z=" + z +
+            '}';
+    }
+}
